/*车辆管理页面JS
 * 
 */
mui.init({
	beforeback: function() {
		//获得父页面的webview
		var list = plus.webview.currentWebview().opener();
		if (list.id == "index") {
			//触发父页面的自定义事件(refresh),从而进行刷新
			mui.fire(list, 'backShake');
		}
		//返回true,继续页面关闭逻辑
		return true;
	}
});
var pageSize = 10;
var startIndex = 1;
var container = mui('#refreshContainer');
var moreElement = null;
mui.plusReady(function() {

	$("#SpeechBtn").on("tap", function() {
		startRecognize(2, function() {
			$("#keywords").val(speechText);
			GetCarList(true, 'down', container);
		});
	});
	container.pullRefresh({
		down: {
			height: 50,
			auto: true,
			contentdown: "下拉刷新",
			contentover: "松开刷新",
			contentrefresh: "刷新中...",
			callback: function() {
				GetCarList(true, 'down', container);
			}
		},
		up: {
			height: 50,
			auto: false,
			contentrefresh: "加载中...",
			contentnomore: '没有更多数据了',
			callback: function() {
				GetCarList(false, 'up', container);
			}
		}
	});
	//显示当前页面
	mui.currentWebview.show();
});
//获取车辆列表
function GetCarList(isClear, refreshType, thisContainer) {
	var ulList = $("#refreshContainer ul");
	if (isClear) {
		startIndex = 1;
		// 判断是否存在“没有更多数据”
		moreElementView('refreshContainer', 'refreshScroll', refreshType, false);
		ulList.children().remove();
		thisContainer.pullRefresh().scrollTo(0, 0, 100);
	}
	var params = {
		keywords: $.trim($("#keywords").val()),
		startIndex: startIndex,
		pageSize: pageSize
	};
	EasyPost("CarManage/GetCarList", params, function(data) {
		var rel = JSON.parse(data);
		if (rel.State != 1) {
			mui.toast(rel.Msg);
			return;
		}
		var carHtml = "";
		data = rel.Data;
		var totalCount = 0;
		startIndex = startIndex + data.length;
		for (var i = 0; i < data.length; i++) {
			var car = data[i];
			if (i == 0) {
				totalCount = parseInt(car.TOTALRECORDS);
			}
			var HEADURL = GetString(car.HEADURL) == "" ? "../../images/CustomerHeader.png" : car.HEADURL;
			var CARTYPE = GetString(car.BRANDNAME) == "" ? "-" : GetString(car.BRANDNAME);
			if (GetString(car.CARTYPENAME) != "") {
				CARTYPE += "/" + GetString(car.CARTYPENAME);
			}
			carHtml += $("#carTpl").html().replace("{{ID}}", car.ID).replace("{{HEADURL}}", HEADURL).replace("{{CARNUMBER}}",
					car.CARNUMBER)
				.replace("{{CARTYPE}}", CARTYPE).replace("{{NAME}}", GetString(car.NAME));
		}
		ulList.append(carHtml);
		if (startIndex >= totalCount) {
			thisContainer.pullRefresh().refresh(true);
			thisContainer.pullRefresh().endPullupToRefresh(true);
			moreElementView('refreshContainer', 'refreshScroll', refreshType, true);
		} else {
			thisContainer.pullRefresh().refresh(true);
			thisContainer.pullRefresh().endPullupToRefresh(false);
		}
	});
}
//关键词按键搜索
$("#keywords").on("keyup", function(e) {
	if (e.originalEvent.keyCode == 13) {
		var keywords = $.trim($("#keywords").val());
		if (keywords != "") {
			document.activeElement.blur();
		}
	}
});
//关键词离开后搜索
$("#keywords").on("blur", function(e) {
	document.activeElement.blur();
	GetCarList(true, 'down', container);
});
// 新增车辆
document.getElementById('AddCar').addEventListener('tap', function() {
	var checkPermission = validateAuthority(null, "车辆管理", "新增车辆");
	if (!checkPermission) {
		return; //没有权限
	}
	plus.nativeUI.showWaiting('加载中...');
	var self = plus.webview.currentWebview();
	var sourcePageID = self.id;
	openDefaultWindow('AddCustomerCar.html', 'AddCustomerCar', sourcePageID);
});
$("#refreshContainer").on("tap", "li", function() {
	var customerId = "";
	var carId = this.id;
	var customerType = 0;
	OpenWindowsNoAuto("../CarManage/CarDetail", {
		customerId: customerId,
		carId: carId,
		customerType: customerType,
		cell: "0"
	}, "CarDetail");
});
