/*语音识别JS
 * 
 */
;
//触发语音识别
var speechText = "";
var speechSetList; //语音设置
var speechType = 1; //1 首页语音事件 2 关键词搜索事件
var speechFun;
var option = {};
//type:1为首页 2为自定义事件
function startRecognize(type, func) {
	try {
		var audioDev = plus.navigator.checkPermission("RECORD");
		switch(audioDev) {
			case 'authorized': //IOS
			case 'notdeny': //ANDROID
				//plus.nativeUI.alert('已开启麦克风权限');
				break;
			case 'denied':
				var btnArray = ['否', '是'];
				mui.confirm('麦克风权限未打开,是否前往设置', '提示', btnArray, function(e) {
					if(e.index == 1) {
						openSetting();
					}
				});
				return;
			case 'undetermined':
				//plus.nativeUI.alert('未确定麦克风权限');
				break;
			case 'unknown':
				//plus.nativeUI.alert('无法查询麦克风权限');
				break;
			default:
				plus.nativeUI.alert('不支持语音输入');
				break;
		}
		speechType = "";
		speechType = type;
		speechFun = func;
		options = {};
		options.engine = 'baidu'; //"baidu"-百度语音识别； "iFly"-讯飞语音识别
		//options.nbest=3;//用于指定识别结果识别包括多候选结果。如nbest:3，识别返回3个候选结果，默认值为1。
		options.punctuation = 'false'; //true表示识别结果文本中包含标点符号，false表示识别结果文本中不包含标点符号。 默认值为true。
		options.timeout = 1000;
		speechText = "";
		plus.speech.startRecognize(options, function(s) {
			s = String(s);
			if(s != null) {
				speechText = s.replace("-", "");
			}
			switch(speechType) {
				case 1: //首页语音事件
					//speechText='查询京69854的消费记录';
					handleResult();
					break;
				case 2: //关键词搜索事件
					GetBdSpeechSynthesisResult("正在搜索");
					speechFun();
					break;
			}
			return;
		}, function(e) {
			recognizeFail(e);
			return;
		});
		mui.later(function() {
			//未说话
			if(speechText == "") {
				showFailSpeech("这个问题难倒我了，等我学会了再告诉您");
				stopRecognize();
			}
		}, 10000)
	} catch(e) {
		mui.alert("打开语音失败：" + e.description)
	}
}
//停止识别
function stopRecognize() {
	plus.speech.stopRecognize();
}
//处理识别结果
var v_PARAMS = {};
var v_URL = null;
var v_BUSINESS = null;

//语音识别失败
function recognizeFail(e) {
	switch(e.code) {
		case 3001: //ANDROID		
			var btnArray = ['否', '是'];
			mui.confirm('麦克风权限未打开,是否前往设置', '提示', btnArray, function(e) {
				if(e.index == 1) {
					openSetting();
				}
			});
			break;
		default:
			//showFailSpeech("这个问题难倒我了，等我学会了再告诉您");
			break;
	}
}
//首页语音识别结果处理
function handleResult() {
	plus.nativeUI.showWaiting();
	EasyPost("AppMain/GetSpeechResult", {
		speechText: speechText
	}, function(data) {
		var rel = JSON.parse(data);
		var list = "";
		list = rel.Data;
		switch(rel.State) {
			case 0:
				GetBdSpeechSynthesisResult("正在打开");
				if(list.length==0){
					showFailSpeech(rel.Msg);
					return;
				}
				if(list.length == 1) {
					v_URL = list[0].URL;
					v_BUSINESS = list[0].BUSINESS;
				} else {
					showSuccessSpeech("打开", list);
					return;
				}
				var checkPermission = validateAuthorityByPath(v_URL, v_BUSINESS);
				if(!checkPermission) {
					return; //没有权限
				}
				if("配件查询" == v_BUSINESS && UserInfo.serviceId() == "324aea7544ca4fc19c512918c94f2727") {
					v_URL = 'partsSearch';
				}
				v_URL = v_URL.replace("../", "");
				$(".bg").removeClass("ShowSpeech");
				MyOpenWindows(v_URL, v_PARAMS, v_BUSINESS);
				startPlay("../mp3/11040.mp3");
				plus.device.vibrate(500);
				break;
			case 1:
				GetBdSpeechSynthesisResult("正在查询");
				v_URL = list[0].URL;
				v_BUSINESS = list[0].BUSINESS;
				var result = list[0].DATA;
				if(result.length==0){
					showFailSpeech(rel.Msg);
					return;
				}
				if(result.length == 1) {
					switch(v_BUSINESS) {
						case '消费记录':
							v_PARAMS = {
								customerId: result[0].CUSTOMERID,
								carId: result[0].CARID,
								cell: 1,
								customerType: 0
							};
							break;
						case '检车记录':
							v_PARAMS = {
								customerId: result[0].CUSTOMERID,
								carId: result[0].CARID,
								cell: 2,
								customerType: 0
							};
							break;
						case '车辆详情':
							v_PARAMS = {
								customerId: result[0].CUSTOMERID,
								carId: result[0].CARID,
								cell: 0,
								customerType: 0
							};
							break;
						case '客户详情':
							var fireData = {
								customerID: result[0].CUSTOMERID,
								customerShopID: result[0].SHOPID
							};
							v_PARAMS = {
								fireData: fireData
							}
							break;
						default:
							showFailSpeech(rel.Msg);
							return;
					}
				} else {
					showSuccessSpeech("查询", result);
					return;
				}
				var checkPermission = validateAuthorityByPath(v_URL, v_BUSINESS);
				if(!checkPermission) {
					return; //没有权限
				}
				$(".bg").removeClass("ShowSpeech");
				MyOpenWindows(v_URL, v_PARAMS, v_BUSINESS);
				startPlay("../mp3/11040.mp3");
				plus.device.vibrate(500);
				break;
			default:
				showFailSpeech(rel.Msg);
				break;
		}
	});
}

function showSuccessSpeech(type, list) {
	var html = "";
	var permissionList = plus.storage.getItem('permissionList');
	permissionList = JSON.parse(permissionList);

	for(var i = 0; i < list.length; i++) {
		var li = list[i];
		var img = "../images/speech2.png";
		var content = type == "打开" ? li.BUSINESS : li.CARNUMBER;
		for(var j = 0; j < permissionList.length; j++) {
			var tp = permissionList[j];
			if(type == "打开" && tp.FINALPATH == li.URL) { // 菜单判断
				img = tp.ICON;
				break;
			}
		}
		html += $("#speechPl").html()
			.replace("{{img}}", img)
			.replace("{{pContent}}", content)
			.replace("{{lblContent}}", "")
			.replace("{{detail}}", JSON.stringify(li).replace(/\"/g, "'"));
	}
	GetBdSpeechSynthesisResult("查询到以下内容");
	$("#pTitle").text("");
	$("#lblTitle").text("你是否要" + type + "如下模块/内容:");
	$("#speechUl").html(html);
	$(".bg").addClass("ShowSpeech");
}

function showFailSpeech(msg) {
	v_URL = null;
	v_BUSINESS = null;
	v_PARAMS = {};
	GetBdSpeechSynthesisResult(msg);
	$("#pTitle").text(msg);
	$("#lblTitle").text("你可以这样问我:");
	var html = $("#speechPl").html()
		.replace("{{img}}", "../images/speech2.png")
		.replace("{{pContent}}", "如何打开功能")
		.replace("{{lblContent}}", "打开库存查询");
	html += $("#speechPl").html()
		.replace("{{img}}", "../images/speech1.png")
		.replace("{{pContent}}", "如何查询车辆信息")
		.replace("{{lblContent}}", "查询闽D88888的车辆详情");
	html += $("#speechPl").html()
		.replace("{{img}}", "../images/speech3.png")
		.replace("{{pContent}}", "如何查询客户信息")
		.replace("{{lblContent}}", "查询18964753256的客户详情");
	html += $("#speechPl").html() 
		.replace("{{img}}", "../images/speech5.png")
		.replace("{{pContent}}", "如何查询客户车辆消费记录")
		.replace("{{lblContent}}", "查询闽D88888的消费记录");
	html += $("#speechPl").html()
		.replace("{{img}}", "../images/speech6.png")
		.replace("{{pContent}}", "如何查询客户车辆的检车记录")
		.replace("{{lblContent}}", "查询闽D88888的检车记录");
		
	$("#speechUl").html(html);
	$(".bg").addClass("ShowSpeech");
}