var container = mui('.pullRefresh');
var itemList = new Array(); // 存储盘点商品的信息
var idList = new Array(); // 存储盘点商品的库存管理Id
var openLocation = 0; // 判断是否开启库位
mui.init();
mui.plusReady(function() {
	init();

	$("#SpeechBtn").on("tap", function() {
		startRecognize(2, function() {
			$("#keywords").val(speechText);
			GetCheckProList(true, 'down', container)
		});
	});
	var self = plus.webview.currentWebview();
	self.setStyle({
		popGesture: 'hide',
		// popGesture: (String 类型 )窗口的侧滑返回功能
		//可取值"none"：无侧滑返回功能;
		//"close"：侧滑返回关闭Webview窗口;
		//"hide"：侧滑返回隐藏webview窗口。 仅iOS平台支持。
	});
	container.pullRefresh({
		down: {
			height: 50,
			auto: true,
			contentdown: "下拉刷新",
			contentover: "松开刷新",
			contentrefresh: "刷新中...",
			callback: function() {
				setTimeout(function() {
					GetCheckProList(true, 'down', container);
					container.pullRefresh().endPulldownToRefresh();
				}, 1000);
			}
		},
		up: {
			height: 100,
			auto: false,
			contentrefresh: "加载中...",
			contentnomore: "没有更多数据了",
			callback: function() {
				// 传入false则不刷新
				setTimeout(function() {
					if(container[0].hasNext) {
						GetCheckProList(false, 'up', container);
					} else {
						if(container[0].page >= container[0].totalCount) {
							container.pullRefresh().endPullupToRefresh(true);
						} else {
							container.pullRefresh().endPullupToRefresh(false);
						}
					}
				}, 1000);
			}
		}
	});
});

function init() {
	$("#noWarehouse").show();
	$("#refreshContainer").hide();
}

function GetCheckProList(reload, refreshType, box, search = 0) {
	//console.log(JSON.stringify(itemList));
	UserInfo.has_login(); // 是否登录超时
	box[0].totalCount = 0;
	if(reload) {
		box[0].page = 0;
		box[0].hasNext = true;
		$(".mui-table-view").html("");
		// 如果直接手动下拉刷新,不是通过关键字搜索下拉刷新，则初始化盘点统计
		if(search == 0) {
			idList = []; // 初始化盘点
			itemList = [];
			$(".CheckCollect").hide();
			$(".CheckCollect span").children('i').text(0);
		}
	}
	var warehouseId = $("#warehouseId").val();
	var classId = $("#productclassId").val();
	var stockState = $(".StockState").find("a.actived").text();
	var keywords = $.trim($("#keywords").val());
	var shopId = UserInfo.operaShopId();
	var params = {
		timeout: 5000,
		shopId: shopId,
		keywords: keywords,
		classId: classId,
		warehouseId: warehouseId,
		stockState: stockState,
		startIndex: box[0].page,
	};
	EasyPost("StoreCheck/GetCheckProList", params, function(result) {
		var rel = JSON.parse(result);
		if(rel.state == 1) {
			var ListData = rel.data;
			openLocation = rel.data2;
			var ListHtml = "";
			if(ListData.length > 0) {
				ListData.forEach(item => {
					index = idList.indexOf(item.ID);
					if(index > -1) {
						item.OPNUM = itemList[index].CHECKNUM;
						item.DIFFNUM = parseFloat(itemList[index].CHECKNUM - itemList[index].STOCKNUM).toFixed(2);
						item.CHECKFLAG = itemList[index].CHECKFLAG; // 盘点标记  -1: 盘亏 0：无差异 1：盘盈
					} else {
						item.OPNUM = item.STOCKNUM;
						item.DIFFNUM = 0;
						item.CHECKFLAG = "";
					}
				});
				for(var i = 0; i < ListData.length; i++) {
					if(i == 0) {
						box[0].totalCount = ListData[i].TOTALRECORDS;
					}
					ListHtml += $("#CheckAddTpl").html().replace("{{CHECKFLAG}}", ListData[i].CHECKFLAG)
						.replace("{{ID}}", ListData[i].ID)
						.replace("{{WAREHOUSEID}}", ListData[i].WAREHOUSEID)
						.replace("{{PRODUCTNAME}}", ListData[i].PRODUCTNAME)
						.replace("{{ATTRIBUTEVALNAME}}", ListData[i].ATTRIBUTEVALNAME)
						.replace("{{WAREHOUSENAME}}", ListData[i].WAREHOUSENAME)
						.replace("{{LOCATION}}", (openLocation == 1 && ListData[i].LOCATION != '' ? "(" + ListData[i].LOCATION + ")" : ""))
						.replace("{{OPNUM}}", ListData[i].OPNUM) // 如果操作，保留操作数量
						.replace("{{STOCKNUM}}", ListData[i].STOCKNUM)
						.replace("{{DIFFNUM}}", ListData[i].DIFFNUM)
				}
			}
			$(".mui-table-view").append(ListHtml);
			var length = $(".mui-table-view").find("li").length;
			for(var i = 0; i < length; i++) {
				var checkVal = $(".mui-table-view").children("li:eq(" + i + ")").children("input[name='checkFlag']").val();
				var diffNumDom = $(".mui-table-view").children("li:eq(" + i + ")").find('p.diffNum').children("i");
				if(checkVal === "1") {
					diffNumDom.css("color", "blue");
				} else if(checkVal === "0") {
					diffNumDom.css("color", "green");
				} else if(checkVal === "-1") {
					diffNumDom.css("color", "red");
				}
			}
			box[0].page = box[0].page + ListData.length;
			if(box[0].page >= box[0].totalCount) {
				box[0].hasNext = false;
				box.pullRefresh().refresh(true);
				box.pullRefresh().endPullupToRefresh(true);
			} else {
				box.pullRefresh().refresh(true);
				box.pullRefresh().endPullupToRefresh(false);
			}
			$(".mui-numbox-btn-minus").on('tap', function() {
				var opNum = $(this).next('input.mui-numbox-input').val();
				opNum = Number(parseFloat(opNum).toFixed(2));
				opNum = parseFloat(opNum - 1).toFixed(2);
				if(opNum < 0) {
					mui.toast("盘点数量不能为负数！");
					return;
				}
				$(this).next('input.mui-numbox-input').val(opNum);
				calculationCheck(this, opNum);
			});
			$(".mui-numbox-btn-plus").on('tap', function() {
				var opNum = $(this).prev('input.mui-numbox-input').val();
				opNum = Number(parseFloat(opNum).toFixed(2));
				opNum = parseFloat(opNum + 1).toFixed(2);
				$(this).prev('input.mui-numbox-input').val(opNum);
				calculationCheck(this, opNum);
			});
			$("input.mui-numbox-input").on('keyup', function(e) {
				if(e.originalEvent.keyCode == 13) {
					document.activeElement.blur();
					//软键盘弹出时mui('.pullRefresh').scroll().element.scrollTop值会增加 
					//在软键盘收回时应设置mui('.pullRefresh').scroll().element.scrollTop=0;恢复正常滑动。
					mui('.pullRefresh').scroll().element.scrollTop = 0;
					var opNum = parseFloat($(this).val()).toFixed(2);
					if(isNaN(opNum)) {
						mui.toast('输入格式有误，请重新输入！');
						$(this).focus();
						return;
					}
					if(opNum < 0) {
						mui.toast('盘点数量不能为负数！');
						$(this).focus();
						return;
					}
					calculationCheck(this, opNum);
				}
			});
			// 商品操作数量输入框失去焦点 判断数量和计算差异
			$("input.mui-numbox-input").on('blur', function() {
				var opNum = parseFloat($(this).val()).toFixed(2);
				if(isNaN(opNum)) {
					mui.toast('输入格式有误，请重新输入！');
					$(this).focus();
					return;
				}
				if(opNum < 0) {
					mui.toast('盘点数量不能为负数！');
					$(this).focus();
					return;
				}
				calculationCheck(this, opNum);
			});
		} else {
			mui.toast(rel.msg);
			return;
		}
	});
}
// 计算盘点差异数 盘点种类数量 盘盈 盘亏
function calculationCheck(thisLi, opNum) {
	var stockId = $(thisLi).parents('li').children('input[name="stockId"]').val();
	var checkFlag = $(thisLi).parents('li').children('input[name="checkFlag"]').val();
	var diffNumDom = $(thisLi).parents(".ListBottom").find("p.diffNum").children("i"); // 差异数量
	var stockNum = $(thisLi).parents(".ListBottom").find("label").children("i").text(); // 库存数量
	var productName = $(thisLi).parents('li').find(".ListTop label").text();
	var preDiffNum = Number(diffNumDom.text()); // 差异数量
	var diffNum = Number(opNum - parseFloat(stockNum).toFixed(2)); //结果差异数量 = 操作数量 - 库存数量
	diffNumDom.text(parseFloat(diffNum).toFixed(2));
	diffNum < 0 ? diffNumDom.css("color", "red") : (diffNum > 0 ? diffNumDom.css("color", "blue") : diffNumDom.css("color",
		"green"));
	if($(".CheckCollect").is(":hidden")) {
		$(".CheckCollect").show();
	}
	var gainNum; // 盘盈结果总数量
	var lossNum; // 盘亏结果总数量
	var preGainNum = Number($(".CheckCollect").find('span:eq(1) i').text()); // 盘盈总数量
	var preLossNum = Number($(".CheckCollect").find('span:eq(2) i').text()); // 盘亏总数量
	if(diffNum > 0) {
		if(preDiffNum < 0) {
			lossNum = parseFloat(preLossNum - Math.abs(preDiffNum)).toFixed(2);
			lossNum = lossNum < 0 ? 0 : lossNum;
			$(".CheckCollect").find('span:eq(2) i').text(lossNum);
		} else {
			preGainNum = preGainNum - preDiffNum;
		}
		gainNum = parseFloat(preGainNum + diffNum).toFixed(2);
		$(".CheckCollect").find('span:eq(1) i').text(gainNum);
	} else if(diffNum < 0) {
		if(preDiffNum >= 0) {
			gainNum = parseFloat(preGainNum - preDiffNum).toFixed(2);
			gainNum = gainNum < 0 ? 0 : gainNum;
			$(".CheckCollect").find('span:eq(1) i').text(gainNum);
		} else {
			preLossNum = preLossNum - Math.abs(preDiffNum);
		}
		lossNum = parseFloat(preLossNum + Math.abs(diffNum)).toFixed(2);
		$(".CheckCollect").find('span:eq(2) i').text(lossNum);
	} else { // 差异数为0 
		if(preDiffNum > 0) {
			gainNum = parseFloat(preGainNum - preDiffNum).toFixed(2);
			$(".CheckCollect").find('span:eq(1) i').text(gainNum);
		} else {
			lossNum = parseFloat(preLossNum - Math.abs(preDiffNum)).toFixed(2);
			$(".CheckCollect").find('span:eq(2) i').text(lossNum);
		}
	}
	//  统计盘点种类数量 和 记录盘点的商品信息 
	var checkFlag = $(thisLi).parents('li').children('input[name="checkFlag"]').val();
	var checkNum = $(thisLi).parent('div').children('input.mui-numbox-input').val();
	var checkFlagDom = $(thisLi).parents('li').children('input[name="checkFlag"]');
	if(checkFlag == '') // 不能使用checkFlag 判断是否单据盘点
	{
		checkFlag = diffNum < 0 ? -1 : (diffNum > 0 ? 1 : 0); // 盘点标记 1：盘盈 0：无损益 -1 盘亏
		var checkCount = parseInt($(".CheckCollect").find('span:eq(0) i').text()); // 盘点种类数量
		checkCount++;
		$(".CheckCollect").find('span:eq(0) i').text(checkCount);
		var item = new Object();
		item = {
			ID: stockId,
			STOCKNUM: stockNum,
			CHECKNUM: checkNum, // 每次 增加减少修改数量， checkNum会变化
			PRODUCTNAME: productName,
			CHECKFLAG: checkFlag
		};
		idList.push(stockId); // 记录当前商品在itemList上的位置
		itemList.push(item);
	} else { // 已盘点的商品，新增减少修改数量，变化的只是checkNum
		checkFlag = diffNum < 0 ? -1 : (diffNum > 0 ? 1 : 0); // 盘点标记 1：盘盈 0：无损益 -1 盘亏
		index = idList.indexOf(stockId);
		itemList[index].CHECKNUM = checkNum;
		itemList[index].CHECKFLAG = checkFlag;
	}
	diffNum < 0 ? checkFlagDom.val(-1) : (diffNum > 0 ? checkFlagDom.val(1) : checkFlagDom.val(0)); // 盘点标记 1：盘盈 0：无损益 -1 盘亏
}
// 关键字按键搜索
$("#keywords").on("keyup", function(e) {
	if(e.originalEvent.keyCode == 13) {
		//var keywords = $.trim(mui('#keywords')[0].value);
		document.activeElement.blur();
		GetCheckProList(true, 'down', container, 1);
	}
});
//关键词离开后搜索
$("#keywords").on('blur', function(e) {
	document.activeElement.blur();
	//GetCheckProList(true, 'down', container, 1);
});
$("#searchBtn").on('tap', function(e) {
	document.activeElement.blur();
	GetCheckProList(true, 'down', container, 1);
});
$(".SaveBtn a").on("tap", function() {
	// 判断是否有商品盘点
	if(itemList.length == 0) {
		mui.toast("请选择盘点的商品！");
		return;
	}
	if(this.id == 'SaveCheck') {
		type = 0;
		saveCheck(type);
	} else {
		type = 1;
		saveCheck(type);
	}
});
// 保存 / 保存并调整 新增盘点单据
function saveCheck(type) {
	// 获取盘点的商品信息
	var params = {
		type: type,
		itemList: itemList,
		shopId: UserInfo.operaShopId(),
		warehouseId: $("#warehouseId").val()
	};
	EasyPost("/StoreCheck/Save", params, function(result) {
		var rel = JSON.parse(result);
		if(rel.state == 1) {
			if(type == 0) {
				OpenWindowsNoAuto('CheckIndex', {}, 'CheckIndex');
			} else {
				OpenWindowsNoAuto('LossIndex', {}, 'LossIndex');
			}
		} else {
			mui.toast(rel.msg);
			return;
		}
	});
}