var container = mui('#refreshContainer');
mui.init();
mui.plusReady(function() {
	init();
	initDate();
	var self = plus.webview.currentWebview();
	self.setStyle({
		popGesture: 'hide'
	});

	$("#SpeechBtn").on("tap", function() {
		startRecognize(2, function() {
			$("#keywords").val(speechText);
			GetCheckList(true, 'down', container);
		});
	});
	// firstLoad = true;
	container.pullRefresh({
		down: {
			height: 50,
			auto: true,
			contentdown: "下拉刷新",
			contentover: "松开刷新",
			contentrefresh: "刷新中...",
			callback: function() {
				GetCheckList(true, 'down', container);
			}
		},
		up: {
			height: 100,
			auto: false,
			contentrefresh: "加载中...",
			contentnomore: "没有更多数据了",
			callback: function() {
				// 传入false则不刷新
				if(container[0].hasNext) {
					GetCheckList(false, 'up', container);
				} else {
					if(container[0].page >= container[0].totalCount) {
						container.pullRefresh().endPullupToRefresh(true);
					} else {
						container.pullRefresh().endPullupToRefresh(false);
					}
				}
			}
		}
	});
	// 显示当前页面
	mui.currentWebview.show();
});
mui.back = function() {
	var self = plus.webview.currentWebview();
	if(self.opener().id=="index"){
		self.close();
		return;
	}
	MyOpenWindows('Classify', {}, 'Classify');
};

function init() {
	document.getElementById('keywords').value = '';
}
// 初始化时间
function initDate() {
	var firstDate = new Date();
	firstDate.setDate(1); //第一天
	var endDate = new Date(firstDate);
	endDate.setMonth(firstDate.getMonth() + 1);
	endDate.setDate(0);
	$(".start").val(new XDate(firstDate).toString('yyyy-MM-dd'));
	$(".end").val(new XDate(endDate).toString('yyyy-MM-dd'));
}

function GetCheckList(reload, refreshType, box) {
	UserInfo.has_login(); // 是否登录超时

	setTimeout(function() {
		box[0].totalCount = 0;
		if(reload) {
			box[0].page = 0;
			box[0].hasNext = true;
			$(".mui-table-view").html("");
			box.pullRefresh().endPulldownToRefresh();
		}
		var warehouseId = $("#warehouseId").val();
		var creatorId = $("#creatorId").val(); // 制单人
		var startDate = $("#startDate").val();
		var endDate = $("#endDate").val();
		var shopId = UserInfo.operaShopId();
		var keywords = $.trim($("#keywords").val());
		var params = {
			timeout: 5000,
			shopId: shopId,
			keywords: keywords,
			warehouseId: warehouseId,
			creatorId: creatorId,
			startDate: startDate,
			endDate: endDate,
			startIndex: box[0].page,
		};
		EasyPost("StoreCheck/GetCheckList", params, function(result) {
			var rel = JSON.parse(result);
			if(rel.state == 1) {
				var ListData = rel.data;
				var ListHtml = "";
				if(ListData.length > 0) {
					for(var i = 0; i < ListData.length; i++) {
						if(i == 0) {
							box[0].totalCount = ListData[i].TOTALRECORDS;
						}
						ListHtml += $("#CheckListTpl").html().replace("{{ID}}", ListData[i].ID)
							.replace("{{CODE}}", ListData[i].CODE)
							.replace("{{NUMBERS}}", ListData[i].TOTALCOUNT) // 盘点商品种类数量
							.replace("{{GAINNUM}}", ListData[i].GAINNUM) // 盘盈数量
							.replace("{{LOSSNUM}}", ListData[i].LOSSNUM) // 盘亏数量
							.replace("{{WAREHOUSEID}}", ListData[i].WAREHOUSEID)
							.replace("{{WAREHOUSENAME}}", ListData[i].WAREHOUSENAME)
							.replace("{{CREATOR}}", ListData[i].CREATOR)
							.replace("{{CREATETIME}}", ListData[i].CREATETIME)
					}
				}
				$(".mui-table-view").append(ListHtml);
				box[0].page = box[0].page + ListData.length;
				if(box[0].page >= box[0].totalCount) {
					box[0].hasNext = false;
					box.pullRefresh().refresh(true);
					box.pullRefresh().endPullupToRefresh(true);
				} else {
					box.pullRefresh().refresh(true);
					box.pullRefresh().endPullupToRefresh(false);
				}
			} else {
				mui.toast(rel.msg);
				return;
			}
		});
	}, 1000);
}

// 关键词按键搜索
$("#keywords").on("keyup", function(e) {
	if(e.originalEvent.keyCode == 13) {
		var keywords = $.trim(mui('#keywords')[0].value);
		if(keywords != "") {
			document.activeElement.blur();
			container.pullRefresh().pulldownLoading();
		}
	}
});
//关键词离开后搜索
$("#keywords").on('blur', function(e) {
	document.activeElement.blur();
	container.pullRefresh().pulldownLoading();
});

// 点击盘点单据列表指定单据跳转
mui('.mui-table-view').on('tap', 'li', function() {
	var checkId = $(this).children('input[name="checkId"]').val();
	var code = $(this).find('.code').text(); // 单据编号
	var numbers = $(this).find('.numbers').text(); // 盘点种类数量
	var gainNum = $(this).find('.gainnum').text(); // 盘盈总数量
	var lossNum = $(this).find('.lossnum').text(); // 盘亏总数量
	var warehouseId = $(this).find('input[name="warehouseId"]').val(); // 仓库Id
	var warehouseName = $(this).find('.warehousename').text(); // 仓库
	var creator = $(this).find('.creator').text(); // 制单人
	var createtime = $(this).find('.createtime').text(); // 制单时间
	var checkInfo = {
		checkId: checkId,
		code: code,
		numbers: numbers,
		gainNum: gainNum,
		lossNum: lossNum,
		warehouseId: warehouseId,
		warehouseName: warehouseName,
		creator: creator,
		createtime: createtime
	};
	OpenWindowsNoAuto('CheckDetail', {
		checkId: checkId,
		checkInfo: checkInfo
	}, 'CheckDetail');
});

$("#checkAdd").on('tap', function() {
	var checkPermission = validateAuthority(null, "盘点单", "新建盘点单");
	if(!checkPermission) {
		return; //没有权限
	}
	MyOpenWindows('CheckAdd', {}, 'CheckAdd');
});