var checkId;
var detailData;
var openLocation = 0; // 判断是否开启库位
var supplierList = null; // 供应商列表
var locationList = null; // 库位列表
mui.plusReady(function() {
	var self = plus.webview.currentWebview();
	self.setStyle({
		popGesture: 'hide'
	});
	checkId = self.checkId;
	DetailData(checkId);
	// 显示当前页面
	mui.currentWebview.show();
});

function DetailData(checkId) {
	var params = {
		checkId: checkId
	}
	EasyPost("StoreDifferent/GetCheckInfo", params, function(result) {
		var rel = JSON.parse(result);
		if(rel.state == 1) {
			billData = rel.data;
			detailData = rel.data2;
			openLocation = rel.data3;
			supplierList = rel.data4;
			locationList = rel.data5;
			$("#code").text("单据编号:" + billData[0].CODE);
			$("#gain").text(billData[0].GAINNUM + "  (" + billData[0].GAINAMOUNT + "元)");
			$("#loss").text(billData[0].LOSSNUM + "  (" + billData[0].LOSSAMOUNT + "元)");
			$("#warehouseId").val(billData[0].WAREHOUSEID);
			$("#warehouseName").text(billData[0].WAREHOUSENAME);
			$("#creator").text(billData[0].CREATOR);
			$("#createtime").text(billData[0].CREATETIME);

			var detailHtml = "";
			for(var i = 0; i < detailData.length; i++) {
				detailHtml += $("#DetailTpl").html().replace("{{PRODUCTSKUID}}", detailData[i].PRODUCTSKUID)
					.replace("{{PRODUCTNAME}}", detailData[i].PRODUCTNAME)
					.replace("{{ATTRIBUTEVALNAME}}", detailData[i].ATTRIBUTEVALNAME)
					.replace("{{SUPPLIER}}", (detailData[i].TYPE == 1 ? "请选择供应商" : (detailData[i].SUPPLIER == null ? "-" : detailData[i].SUPPLIER)))
					.replace("{{LOCATION}}", (detailData[i].TYPE == 1 ? "请选择库位" : (detailData[i].LOCATION == null ? "-" : detailData[i].LOCATION)))					
					.replace("{{NUM}}", detailData[i].ARRIVALNUM) // 账面数
					.replace("{{CHECKNUM}}", detailData[i].NUM) // 盘点数
					.replace("{{DIFFNUM}}", detailData[i].DIFFNUM) // 差异数
					.replace("{{TYPE}}", detailData[i].TYPE == 1 ? "盘盈" : "盘亏") // 盘盈 / 盘亏
					.replace("{{AMOUNTHTML}}", detailData[i].TYPE == 1 ? '<input type="number" name="amount" value="' + detailData[i].GAINAMOUNT + '" />' : detailData[i].LOSSAMOUNT)
					.replace("{{DETAILID}}", detailData[i].DETAILID)

					// 盘盈
					.replace("{{Unadjusted}}", detailData[i].TYPE == 1 ? "Unadjusted" : "")
					// 盘亏
					.replace("{{SUPPLIERID}}",  detailData[i].TYPE == 0 ? (detailData[i].SUPPLIERID == null ? "" : detailData[i].SUPPLIERID) : "")
					.replace("{{SUPPLIERNAME}}", detailData[i].TYPE == 0 ? (detailData[i].SUPPLIER == null ? "" : detailData[i].SUPPLIER) : "")
					.replace("{{LOCATIONID}}",  detailData[i].TYPE == 0 ? (detailData[i].LOCATIONID == null ? "" : detailData[i].LOCATIONID) : "")
					.replace("{{LOCATIONNAME}}", detailData[i].TYPE == 0 ? (detailData[i].LOCATION == null ? "" : detailData[i].LOCATION) : "")

			}
			if(detailHtml != "") {
				$("#detailList").html(detailHtml);
			}
			if(openLocation != 1) {
				$('a.location').css('display', 'none');
			}
			$("#detailList").find("input[name='amount']").on("keyup", function(e) {
				if(e.originalEvent.keyCode == 13) {
					document.activeElement.blur();
					var amountVal = $.trim(this.value);
					if(amountVal == "" || amountVal == null) {
						mui.toast("金额输入格式错误，请重新输入！");
						$(this).val("");
						return;
					}
					if(isNaN(amountVal)) {
						mui.toast("金额输入格式错误，请重新输入！");
						$(this).val("");
						return;
					}
				}
			});
			$("#detailList").find("input[name='amount']").on('blur', function() {
				document.activeElement.blur();
				var amountVal = $.trim(this.value);
				if(amountVal == "" || amountVal == null) {
					mui.toast("金额输入格式错误，请重新输入！");
					$(this).val("");
					return;
				}
				if(isNaN(amountVal)) {
					mui.toast("金额输入格式错误，请重新输入！");
					$(this).val("");
					return;
				}
			});
			
			// 选择供应商
			mui('.Unadjusted').on('tap', 'a.supplier', function() {
				var s = this;
				var sPicker = new mui.PopPicker({
					layer: 1,
					buttons: ['取消', '确定']
				});
				sPicker.setData(supplierList);
				sPicker.show(function(items) {
					if(items[0].value != undefined) {
						$(s).attr('data-supplierID', items[0].value);
						$(s).attr('data-supplierName', items[0].text);
						$(s).find('span').text(items[0].text);

					}
				});
			});

			// 选择库位
			mui('.Unadjusted').on('tap', 'a.location', function() {
				var l = this;
				var lPicker = new mui.PopPicker({
					layer: 1,
					buttons: ['取消', '确定']
				});
				lPicker.setData(locationList);
				lPicker.show(function(items) {
					if(items[0].value != undefined) {
						$(l).attr('data-locationID', items[0].value);
						$(l).attr('data-location', items[0].text);
						$(l).find('span').text(items[0].text);

					}
				});
			});
		} else {
			mui.toast('获取盘点单详情失败！');
			return;
		}
	});
}

// 保存损益单 或 保存并调整损益单
mui(".bottombtn").on('tap', 'a', function() {
	if($(this).text() == '保存') {
		var type = 0;
	} else if($(this).text() == '保存并调整') {
		var type = 1;
	}
	saveDiffBill(checkId, type);
});

function saveDiffBill(checkId, type) {
	var code = $("#code").text().split(':')[1]; // 盘点单据编号
	var warehouseId = $("#warehouseId").val(); // 调出仓库ID
	var checktime = $("#createtime").text(); // 盘点单创建时间
	var postData = new Array();
	detailData.forEach(function(curValue) {
		var costPrice, diffNum;
		// 盘盈 可修改成本价（盘盈金额）
		if(curValue["TYPE"] == 1) {
			diffNum = curValue["DIFFNUM"];
			costPrice = $("input[value='" + curValue['PRODUCTSKUID'] + "']").parents('li').find("input[name='amount']").val();
			
			var supplier =$('#'+curValue['DETAILID']).find('a.supplier');
			var location =$('#'+curValue['DETAILID']).find('a.location');
			curValue["SUPPLIERID"] =$(supplier).attr('data-supplierID');
			curValue["SUPPLIER"] =$(supplier).attr('data-supplierName');
			curValue["LOCATIONID"] =$(location).attr('data-locationID');
			curValue["LOCATION"] =$(location).attr('data-location');
		} else { // 盘亏 无法修改成本价 （盘亏金额）
			diffNum = -curValue["DIFFNUM"];
			costPrice = curValue["COSTPRICE"];
		}
		
		if(openLocation!=1){
		 	curValue["LOCATIONID"] =null;
			curValue["LOCATION"] =null;
		}
		var postObj = new Object();
		postObj = curValue;
		postObj["DIFFNUM"] = parseFloat(diffNum).toFixed(2);
		postObj["COSTPRICE"] = parseFloat(costPrice).toFixed(2);
		postData.push(postObj);
	});
	var params = {
		data: JSON.stringify(postData),
		checkId: checkId,
		code: code,
		warehouseId: warehouseId,
		checktime: checktime,
		type: type
	};
	
	EasyPost("StoreDifferent/GenerateDiffBill", params, function(result) {
		var rel = JSON.parse(result);
		if(rel.state == 1) {
			if(type == 0) {
				mui.toast("保存成功！");
				OpenWindowsNoAuto("LossIndex", {}, "LossIndex");
			} else {
				mui.toast("调整成功！");
				OpenWindowsNoAuto("AdjustIndex", {}, "AdjustIndex");
			}
		} else {
			mui.toast(rel.msg);
			return;
		}
	});
}