var lossId;
var detailData;
var isAdjust = false; // 判断是否调整
var openLocation = 0; // 判断是否开启库位
var supplierList = null; // 供应商列表
var locationList = null; // 库位列表
mui.plusReady(function() {
	var self = plus.webview.currentWebview();
	self.setStyle({
		popGesture: 'hide'
	});
	lossId = self.lossId;
	ExistAdjustBill(lossId);
	DetailData(lossId);
	// 显示当前页面
	mui.currentWebview.show();
});

// 查看是否是已调整的损益单据
function ExistAdjustBill(lossId) {
	EasyPost("StoreDifferent/ExistAdjustBill", {
		lossId: lossId,
		async: false
	}, function(result) {
		var rel = JSON.parse(result);
		if(rel.state == 0) {
			isAdjust = true;
			$(".bottombtn").remove();
			$(".main").css('margin-bottom', "0px");
		}
	});
}

function DetailData(lossId) {
	var params = {
		lossId: lossId
	}
	EasyPost("StoreDifferent/GetDiffDetail", params, function(result) {
		var rel = JSON.parse(result);
		if(rel.state == 1) {
			billData = rel.data;
			detailData = rel.data2;
			openLocation = rel.data3;
			supplierList = rel.data4;
			locationList = rel.data5;
			$("#code").text("单据编号:" + billData[0].CODE);
			$("#finishFlag").text(billData[0].FINISHFLAG);
			$("#gain").text(billData[0].GAINNUM + "  (" + billData[0].GAINAMOUNT + "元)");
			$("#loss").text(Math.abs(billData[0].LOSSNUM) + "  (" + billData[0].LOSSAMOUNT + "元)");
			$("#warehouseId").val(billData[0].WAREHOUSEID);
			$("#warehouseName").text(billData[0].WAREHOUSENAME);
			$("#creator").text(billData[0].CREATOR);
			$("#createtime").text(billData[0].CREATETIME);

			var detailHtml = "";
			for(var i = 0; i < detailData.length; i++) {
				detailHtml += $("#DetailTpl").html().replace("{{PRODUCTSKUID}}", detailData[i].PRODUCTSKUID)
					.replace("{{PRODUCTNAME}}", detailData[i].PRODUCTNAME)
					.replace("{{ATTRIBUTEVALNAME}}", detailData[i].ATTRIBUTEVALNAME)
					.replace("{{SUPPLIER}}", (isAdjust ? (detailData[i].SUPPLIER == null ? "-" : detailData[i].SUPPLIER) : (detailData[i].TYPE == 1 ? "请选择供应商" : (detailData[i].SUPPLIER == null ? "-" : detailData[i].SUPPLIER))))
					.replace("{{LOCATION}}", (isAdjust ? (detailData[i].LOCATION == null ? "-" : detailData[i].LOCATION) : (detailData[i].TYPE == 1 ? "请选择库位" : (detailData[i].LOCATION == null ? "-" : detailData[i].LOCATION))))
					.replace("{{NUM}}", detailData[i].STOCKNUM) // 账面数
					.replace("{{CHECKNUM}}", detailData[i].NUM) // 盘点数
					.replace("{{DIFFNUM}}", detailData[i].DIFFNUM) // 差异数
					.replace("{{TYPE}}", detailData[i].TYPE == 1 ? "盘盈" : "盘亏") // 盘盈 / 盘亏
					.replace("{{AMOUNT}}", detailData[i].TYPE == 1 ? detailData[i].GAINAMOUNT : detailData[i].LOSSAMOUNT)
					.replace("{{DETAILID}}", detailData[i].ID)
					// 盘盈
					.replace("{{Unadjusted}}", !isAdjust && detailData[i].TYPE == 1 ? "Unadjusted" : "")
					// 盘亏
					.replace("{{SUPPLIERID}}", !isAdjust && detailData[i].TYPE == 0 ? (detailData[i].SUPPLIERID == null ? "" : detailData[i].SUPPLIERID) : "")
					.replace("{{SUPPLIERNAME}}", !isAdjust && detailData[i].TYPE == 0 ? (detailData[i].SUPPLIER == null ? "" : detailData[i].SUPPLIER) : "")
					.replace("{{LOCATIONID}}", !isAdjust && detailData[i].TYPE == 0 ? (detailData[i].LOCATIONID == null ? "" : detailData[i].LOCATIONID) : "")
					.replace("{{LOCATIONNAME}}", !isAdjust && detailData[i].TYPE == 0 ? (detailData[i].LOCATION == null ? "" : detailData[i].LOCATION) : "")
			}
			if(detailHtml != "") {
				$("#detailList").html(detailHtml);
			}
			if(openLocation != 1) {
				$('a.location').css('display', 'none');
			}
			var length = $("#detailList").find('li').length;
			for(var i = 0; i < length; i++) {
				var liDom = $("#detailList").children("li:eq(" + i + ")");
				var text = liDom.find("span.type").text();
				if(text.indexOf("盘盈") > -1) {
					liDom.find(".diffNum").css("cssText", "color: #46fe92 !important;");
				}
				if(text.indexOf("盘亏") > -1) {
					liDom.find(".diffNum").css("cssText", "color: red !important;");
				}
			}

			// 选择供应商
			mui('.Unadjusted').on('tap', 'a.supplier', function() {
				var s = this;
				var sPicker = new mui.PopPicker({
					layer: 1,
					buttons: ['取消', '确定']
				});
				sPicker.setData(supplierList);
				sPicker.show(function(items) {
					if(items[0].value != undefined) {
						$(s).attr('data-supplierID', items[0].value);
						$(s).attr('data-supplierName', items[0].text);
						$(s).find('span').text(items[0].text);

					}
				});
			});

			// 选择库位
			mui('.Unadjusted').on('tap', 'a.location', function() {
				var l = this;
				var lPicker = new mui.PopPicker({
					layer: 1,
					buttons: ['取消', '确定']
				});
				lPicker.setData(locationList);
				lPicker.show(function(items) {
					if(items[0].value != undefined) {
						$(l).attr('data-locationID', items[0].value);
						$(l).attr('data-location', items[0].text);
						$(l).find('span').text(items[0].text);

					}
				});
			});
		} else if(rel.state == 0) {
			$(".bottombtn").remove();
		} else {
			mui.toast('获取损益单详情失败！');
			return;
		}
	});
}

// 调整损益单
mui(".bottombtn").on('tap', 'a', function() {
	//console.log('调整');
	var code = $("#code").text().replace('单据编号:',''); // 损益单单据编号
	var warehouseId = $("#warehouseId").val();
	var createtime = $("#createtime").text();
    
    if(detailData !=undefined && detailData.length>0)
    {
	 	for(var i = 0; i < detailData.length; i++){
	 		if(detailData[i].TYPE==1){
	 			var li =$('#'+detailData[i].ID);
	 			var supplier =$(li).find('a.supplier');
	 			var location =$(li).find('a.location');
	 			
	 			detailData[i].SUPPLIERID =$(supplier).attr('data-supplierID');
	 			detailData[i].SUPPLIER =$(supplier).attr('data-supplierName');
	 			detailData[i].LOCATIONID =$(location).attr('data-locationID');
	 			detailData[i].LOCATION =$(location).attr('data-location');
	 		}
	 		
	 		if(openLocation!=1){
	 			detailData[i].LOCATIONID =null;
	 			detailData[i].LOCATION =null;
	 		}
	 	}
	}
	var params = {
		timeout: 5000,
		detailData: JSON.stringify(detailData),
		lossId: lossId,
		billFromCode: code,
		warehouseId: warehouseId,
		createtime: createtime
	};	
	EasyPost("StoreDifferent/AdjustBill", params, function(result) {
		var rel = JSON.parse(result);
		if(rel.state == 1) {
			// 跳转到调整单
			var adjustId = rel.data; // 调整单Id
			OpenWindowsNoAuto('AdjustIndex', {
				adjustId: adjustId
			}, 'AdjustIndex');
		} else {
			mui.toast(rel.msg);
		}
	});
});