function ocr(url, param, callback) {

	var obj = new Object();
	obj.name = "hzp";
	obj.captureImage = function() {
		var os = plus.os.name.toUpperCase();
		if(os == "IOS") {
			var AVCaptureDevice = plus.ios.importClass("AVCaptureDevice");
			var Status = AVCaptureDevice.authorizationStatusForMediaType("vide");
			if(2 == Status) {
				mui.toast("请确认是否开启相机权限");
				return;
			}
		}
		var cmr = plus.camera.getCamera();
		var res = cmr.supportedImageResolutions[0];
		var fmt = cmr.supportedImageFormats[0];

		cmr.captureImage(function(path) {

				var urlHope = plus.io.convertLocalFileSystemURL(path);
				var img = document.createElement("img");
				img.src = urlHope;
				img.onload = function() {
					var that = this;
					//生成比例 
					var w = that.width;
					var h = that.height;

					//生成canvas
					var canvas = document.createElement('canvas');

					var ctx = canvas.getContext('2d');
					if(EXIF == null) {
						alert("请引入exif.js插件");
						return;
					}
					//获取照片方向角属性，用户旋转控制 ,判断当前图片是否需要做旋转操作。
					EXIF.getData(img, function() {
						EXIF.getAllTags(this);
						/**
						 * 图片的旋转方向信息
						 * 1、图片没有发生旋转
						 * 6、顺时针90°
						 * 8、逆时针90°
						 * 3、180° 旋转
						 */
						Orientation = EXIF.getTag(this, 'Orientation');
						if(Orientation != "" && Orientation != null) {
							// 方向信息，canvas 显示形式，canvas 对象，that,宽度，高度
							rotateImg(Orientation, ctx, canvas, that, w, h, urlHope);
						} else {
							rotateImg(Orientation, ctx, canvas, that, w, h, urlHope);
						}
					});

					//结束
				}

			},
			function(s) {
				if(s.Message != null && s.Message != "") {
					mui.toast("请确认是否开启相机权限");
					return;
				}
			}
		);
	}
	// base64转为file文件类型
	function dataURLtoBlob(dataurl1) {
		var dataURI = dataurl1
		var mimeString = dataURI.split(',')[0].split(':')[1].split(';')[0]; // mime类型
		var byteString = atob(dataURI.split(',')[1]); //base64 解码
		var arrayBuffer = new ArrayBuffer(byteString.length); //创建缓冲数组
		var intArray = new Uint8Array(arrayBuffer); //创建视图
		for(i = 0; i < byteString.length; i += 1) {
			intArray[i] = byteString.charCodeAt(i);
		}
		var blob = new Blob([intArray], {
			type: mimeString
		}); //转成blob
		return blob;
	}

	// 图片上传，将base64的图片转成二进制对象，塞进formdata上传
	function upload(basestr, urlHope) {
		var oristr = basestr;
		basestr = basestr.replace("data:image/jpeg;base64,", "");
		param.Base64 = basestr
		//UploadRepairImg
		//OcrCarNumber
		PQuery(url, param, function(e) {
			callback(e, urlHope);
		});
	}

	// 图片旋转操作并发送到服务器进行识别
	function rotateImg(Orientation, ctx, canvas, that, w, h, urlHope) {
		var width = w,
			height = h;
		// 控制上传图片的宽高 540*1334 540X960
		//		var mWidth=540;
		//		var mHeight=960;
		var mWidth = 960;
		var mHeight = 1366;
		if(width > height && width > mWidth) {
			width = mWidth;
			height = Math.ceil(mWidth * h / w);
		} else if(width < height && height > mHeight) {
			width = Math.ceil(mHeight * w / h);
			height = mHeight;
		}

		canvas.width = width; /*设置新的图片的宽度*/
		canvas.height = height; /*设置新的图片的长度*/
		if(Orientation && Orientation != 1) {
			switch(Orientation) {
				case 6:
					canvas.width = height; /*设置新的图片的宽度*/
					canvas.height = width; /*设置新的图片的长度*/
					// 画布旋转 90度
					ctx.rotate(Math.PI / 2);
					ctx.drawImage(that, 0, -height, width, height);
					break;
				case 3: // 旋转180度
					ctx.rotate(Math.PI);
					ctx.drawImage(that, -width, -height, width, height);
					break;
				case 8: // 旋转-90度
					canvas.width = height;
					canvas.height = width;
					ctx.rotate(3 * Math.PI / 2);
					ctx.drawImage(that, -width, 0, width, height);
					break;
			}
		} else {
			ctx.drawImage(that, 0, 0, width, height);
		}
		var base64 = canvas.toDataURL('image/jpeg', 1); //1z 表示图片质量，越低越模糊。

		upload(base64, urlHope);
		//				plus.nativeUI.closeWaiting();

	};
	return obj;
}

// 返回拍照图片
function ocrImage(type, callback) {
	var obj = new Object();
	obj.name = "wwr";
	obj.captureImage = function() {
		var os = plus.os.name.toUpperCase();
		if(os == "IOS") {
			var AVCaptureDevice = plus.ios.importClass("AVCaptureDevice");
			var Status = AVCaptureDevice.authorizationStatusForMediaType("vide");
			if(2 == Status) {
				callback("请确认是否开启相机权限", 101, null);
				return;
			}
		} else if(os == "ANDROID") {
			var camera = undefined;
			var mCamera = null;
			try {
				camera = plus.android.importClass('android.hardware.Camera');
				mCamera = camera.open();
			} catch(e) {
				callback("请确认是否开启相机权限", 101, null);
				return;
			} finally {
				if(mCamera != null) {
					mCamera.release();
					mCamera = undefined;
				}

				if(camera) {
					camera = undefined;
				}
			}
		}
		var cmr = plus.camera.getCamera();
		var res = cmr.supportedImageResolutions[0];
		var fmt = cmr.supportedImageFormats[0];

		cmr.captureImage(function(path) {
				var urlHope = plus.io.convertLocalFileSystemURL(path);
				callback("读取拍照文件成功", 1, urlHope);
			},
			function(s) {
				mui.alert(s.Message);
				if(s.Message != null && s.Message != "") {
					callback("请确认是否开启相机权限", 101, null);
					return;
				}
			},{resolution:res,format:fmt}
		);
	}
	return obj;
}

// 返回本地相册图片
function ocrOpenAlbum(type, callback) {
	var imgRoot = "_doc/carmera/";
	var filename = type + ".png";
	//从系统相册中选择文件完成后的回调函数
	plus.gallery.pick(function(path) {
		// 选择成功
		var urlHope = plus.io.convertLocalFileSystemURL(path);
		callback("读取拍照文件成功", 1, urlHope);
	}, function(a) {
		// 选择失败
		if(a.message == "没有权限") {
			callback("读取拍照文件错误：请确认是否开启权限", 101, null);
		} else if(a.message.indexOf('用户取消') > -1 || a.message.indexOf('User cancelled') > -1) {
			callback("用户取消", 0, null);
		} else {
			callback("error" + a.message, 102, null);
		}
	}, {
		filter: "image"
	});
}

// 选择图片来源（拍照+本地相册）
function ocrSourceList(type, title, callback) {
	if(mui.os.plus) {
		var a = [{
			title: "拍照"
		}, {
			title: "从手机相册选择"
		}];
		plus.nativeUI.actionSheet({
			title: title,
			cancel: "取消",
			buttons: a
		}, function(b) { /*actionSheet 按钮点击事件*/
			switch(b.index) {
				case 0:
					break;
				case 1:
					/*拍照*/
					{
						var o = new ocrImage(type, callback);
						o.captureImage();
					}
					break;
				case 2:
					/*打开相册*/
					{
						ocrOpenAlbum(type, callback);
					}
					break;
				default:
					break;
			}
		});
	}
}

// 新版ocr
function ocr_new(url, imgPath, param, callback) {
	// 将数据加载到Img
	var img = document.createElement("img");
	img.src = imgPath;
	img.onload = function() {
		var that = this;
		//生成比例 
		var w = that.width;
		var h = that.height;

		//生成canvas
		var canvas = document.createElement('canvas');

		var ctx = canvas.getContext('2d');
		if(EXIF == null) {
			alert("请引入exif.js插件");
			return;
		}
		//获取照片方向角属性，用户旋转控制 ,判断当前图片是否需要做旋转操作。
		EXIF.getData(img, function() {
			EXIF.getAllTags(this);
			/**
			 * 图片的旋转方向信息
			 * 1、图片没有发生旋转
			 * 6、顺时针90°
			 * 8、逆时针90°
			 * 3、180° 旋转
			 */
			Orientation = EXIF.getTag(this, 'Orientation');
			if(Orientation != "" && Orientation != null) {
				// 方向信息，canvas 显示形式，canvas 对象，that,宽度，高度
				rotateImg(Orientation, ctx, canvas, that, w, h, imgPath);
			} else {
				rotateImg(Orientation, ctx, canvas, that, w, h, imgPath);
			}
		});
		// 结束
	}

	// base64转为file文件类型
	function dataURLtoBlob(dataurl1) {
		var dataURI = dataurl1
		var mimeString = dataURI.split(',')[0].split(':')[1].split(';')[0]; // mime类型
		var byteString = atob(dataURI.split(',')[1]); //base64 解码
		var arrayBuffer = new ArrayBuffer(byteString.length); //创建缓冲数组
		var intArray = new Uint8Array(arrayBuffer); //创建视图
		for(i = 0; i < byteString.length; i += 1) {
			intArray[i] = byteString.charCodeAt(i);
		}
		var blob = new Blob([intArray], {
			type: mimeString
		}); //转成blob
		return blob;
	}

	// 图片上传，将base64的图片转成二进制对象，塞进formdata上传
	function upload(basestr, imgPath) {
		var oristr = basestr;
		basestr = basestr.replace("data:image/jpeg;base64,", "");
		param.Base64 = basestr;
		//UploadRepairImg
		//OcrCarNumber
		PQuery(url, param, function(e) {
			callback(e, imgPath);
		});
	}

	// 图片旋转操作并发送到服务器进行识别
	function rotateImg(Orientation, ctx, canvas, that, w, h, imgPath) {
		var width = w,
			height = h;
		// 控制上传图片的宽高 540*1334 540X960
		//		var mWidth=540;
		//		var mHeight=960;
		var mWidth = 960;
		var mHeight = 1366;
		if(width > height && width > mWidth) {
			width = mWidth;
			height = Math.ceil(mWidth * h / w);
		} else if(width < height && height > mHeight) {
			width = Math.ceil(mHeight * w / h);
			height = mHeight;
		}

		canvas.width = width; /*设置新的图片的宽度*/
		canvas.height = height; /*设置新的图片的长度*/
		if(Orientation && Orientation != 1) {
			switch(Orientation) {
				case 6:
					canvas.width = height; /*设置新的图片的宽度*/
					canvas.height = width; /*设置新的图片的长度*/
					// 画布旋转 90度
					ctx.rotate(Math.PI / 2);
					ctx.drawImage(that, 0, -height, width, height);
					break;
				case 3: // 旋转180度
					ctx.rotate(Math.PI);
					ctx.drawImage(that, -width, -height, width, height);
					break;
				case 8: // 旋转-90度
					canvas.width = height;
					canvas.height = width;
					ctx.rotate(3 * Math.PI / 2);
					ctx.drawImage(that, -width, 0, width, height);
					break;
			}
		} else {
			ctx.drawImage(that, 0, 0, width, height);
		}
		var base64 = canvas.toDataURL('image/jpeg', 1); //1z 表示图片质量，越低越模糊。

		upload(base64, imgPath);
		// plus.nativeUI.closeWaiting();
	};
}