//拍照 
function getImage(filename, callback) {
	var os = plus.os.name.toUpperCase();
	if(os == "IOS") {
		var AVCaptureDevice = plus.ios.importClass("AVCaptureDevice");
		var Status = AVCaptureDevice.authorizationStatusForMediaType("vide");
		if(2 == Status) {
			callback("请确认是否开启相机权限", 101, null);
			return;
		}
	}
	var c = plus.camera.getCamera();
	c.captureImage(function(e) { //成功返回	
		plus.io.resolveLocalFileSystemURL(e, function(entry) {
			var s = entry.toLocalURL() + "?version=" + new Date().getTime();
			uploadHead(s, callback); /*上传图片*/
		}, function(e) {
			callback("读取拍照文件错误：请确认是否开启权限", 101, null);
			//console.log("读取拍照文件错误：" + e.message);
		});
	}, function(s) { //错误返回
		console.log(s.Message);
		if(s.Message != null && s.Message != "")
			callback("请确认是否开启相机权限", 101, null);
		//console.log("error" + s);
	}, {
		filename: filename //拍照或摄像文件保存的路径
	})
}
//本地相册选择 
function galleryImg(headerpath, filename, callback) {
	plus.gallery.pick(function(a) { //从系统相册中选择文件完成后的回调函数
			plus.io.resolveLocalFileSystemURL(a, function(entry) {
				plus.io.resolveLocalFileSystemURL(headerpath.replace(filename, ""), function(root) {
					root.getFile(filename, {}, function(file) {
						//文件已存在 
						file.remove(function() {
							//console.log("file remove success");
							entry.copyTo(root, filename, function(e) {
									var e = e.fullPath + "?version=" + new Date().getTime();
									uploadHead(e, callback); /*上传图片*/
									//变更大图预览的src 
									//目前仅有一张图片，暂时如此处理，后续需要通过标准组件实现 
								},
								function(e) {
									callback('copy image fail:' + e.message, 103, null);
									//console.log('copy image fail:' + e.message);
								});
						}, function() {
							callback("delete image fail:" + e.message, 104, null);
							//console.log("delete image fail:" + e.message);
						});
					}, function() {
						//文件不存在 
						entry.copyTo(root, filename, function(e) {
								var path = e.fullPath + "?version=" + new Date().getTime();
								uploadHead(path, callback); /*上传图片*/
							},
							function(e) {
								callback('copy image fail:' + e.message, 103, null);
								//console.log('copy image fail:' + e.message);
							});
					});
				}, function(e) {
					//文件不存在 
					entry.copyTo(root, filename, function(e) {
							var path = e.fullPath + "?version=" + new Date().getTime();
							uploadHead(path, callback); /*上传图片*/
						},
						function(e) {
							callback('copy image fail:' + e.message, 103, null);
							//console.log('copy image fail:' + e.message);
						});
				})
			}, function(e) {
				callback("读取拍照文件错误：" + e.message, 101, null);
				//console.log("读取拍照文件错误：" + e.message);
			});
		},
		function(a) { //从系统相册中选择文件操作错误的回调函数
			if(a.message == "没有权限") {
				callback("读取拍照文件错误：请确认是否开启权限", 101, null);
			} else {
				callback("error" + a.message, 102, null);
			}
		}, { //设置选择文件的参数
			filter: "image"
		})
};

//上传头像图片 
function uploadHead(imgPath, callback) {
	//console.log("imgPath = " + imgPath);
	var image = new Image();
	image.src = imgPath;
	image.style.width = "200px";
	image.style.height = "200px";
	image.onload = function() {
		var imgData = getBase64Image(image);
		//console.log(imgData);
		callback("success", 100, imgData);
	}
}
//将图片压缩转成base64 
function getBase64Image(img) {
	var canvas = document.createElement("canvas");
	var width = img.width;
	var height = img.height;
	// calculate the width and height, constraining the proportions 
	if(width > height) {
		if(width > 100) {
			height = Math.round(height *= 100 / width);
			width = 100;
		}
	} else {
		if(height > 100) {
			width = Math.round(width *= 100 / height);
			height = 100;
		}
	}
	canvas.width = width; /*设置新的图片的宽度*/
	canvas.height = height; /*设置新的图片的长度*/
	var ctx = canvas.getContext("2d");
	ctx.drawImage(img, 0, 0, width, height); /*绘图*/
	var dataURL = canvas.toDataURL("image/png", 1);
	return dataURL.replace("data:image/png;base64,", "");
}