

;(function(mui,document){

    var fn=mui.fn

    // each方法会判断返回值，for方法不判断返回值
    fn.for=function(fn){
        for(var i=0;i<this.length;i++)
        fn.call(this[i],i)

        return this
    }



    // 扩展tap方法
    fn.tap=function(fn,push){
        return this.for(function(){
            this.addEventListener('tap',fn,push)
        })
    }


    // 扩展o方法加事件
    /*
        允许输入两种类型
        类型一
        事件类型，选择器，函数
        类型二
        事件类型，函数，推送/冒泡
    */
    fn.o=function(type,str,fn){
        if(typeof str=='function'){
            return this.for(function(){
                this.addEventListener('tap',str,fn)
            })
        }

        return this.on(type,str,fn)
    }




    // 扩展attr方法
    fn.attr=function(name,value){

        if(arguments.length==2){
            return this.for(function (){
                this.setAttribute(name,value)
            })
        }

        return this[0].getAttribute(name)

    }



    // 扩展attrHas方法
    fn.attrHas=function(name,value){
        return this[0].hasAttribute(name)
    }


    // 扩展attrRemove方法
    fn.attrRemove=function(name){
        return this.for(function(){
            this.removeAttribute(name)
        })
    }


    // 扩展attrToggle方法
    fn.attrToggle=function(name){
        if(this.attrHas(name))
            return this.attrRemove(name)
            return this.attr('name','')
    }



    // 扩展html方法
    fn.html=function(value){

        if(arguments.length){
            return this.for(function(){
                this.innerHTML=value
            })
        }

        return this[0].innerHTML

    }


    // 扩展value方法
    fn.value=function(value){

        if(value){
            return this.for(function(){
                this.value=value
            })
        }

        return this[0].value

    }


    // 扩展find方法
    /*
        只查找第一个元素的子集
    */
    fn.find=function(str){

        var the=this[0]

        var hasId=true

        if(!the.id){
            the.id='id'+new Date().getTime()
            hasId=false
        }

        var m=mui('#'+the.id+' '+str)
        if(!hasId)the.id=''

        return m
    }


    // 扩展dom方法
    /*
        接受4个指令连成的字符串
        < 父级
        > 子集（只参考第一dom节点）
        + 下一个
        < 上一个
    */

    var dom={
        '<':'parentElement',
        '>':'children',
        '+':'nextElementSibling',
        '-':'previousElementSibling',
    }

    fn.dom=function(str){

        var the=this[0]

        str=str.split('')

        for(var i=0;i<str.length;i++){
            the=the[dom[str[i]]]
            if(!the)return null

            if('length' in the){
                if(i==str.length-1)
                return mui(the)

                the=the[0]
            }
        }

        return mui(the)
    }


    // 扩展classAdd方法
    fn.classAdd=function(name){
        return this.for(function(){
            this.classList.add(name)
        })
    }


    // 扩展classRemove方法
    fn.classRemove=function(name){
        return this.for(function(){
            this.classList.remove(name)
        })
    }



    // 扩展classToggle方法
    fn.classToggle=function(name){
        return this.for(function(){
            this.classList.toggle(name)
        })
    }


    // 扩展classHas方法
    fn.classHas=function(name){
        return this[0].classList.contains(name)
    }












// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -







        mui.init()

        mui('.mui-scroll-wrapper').for(function(){
            var the=mui(this)
            if(!the.classHas('pullRefresh')  &&  this.id!='pullrefresh'){
                the.scroll()
            }
        })




        mui(document.body)
        .on('tap','[href]',function(e){
            var href=this.getAttribute('href')

            if(href && href.charAt(0)!='#'){

                if(href=='index-5.html'){
                    if(localStorage.user_login!='true'){
                        href='login.html'
                    }
                }

                setTimeout(function(){
                    mui.openWindow(href)
                },0)
            }
        })

        .on('tap','[toast]',function (){
            mui.toast(this.getAttribute('toast'))
        })












    window.ajax=function(url,data,success,error){
        console.log('传入：' , url , '\n' , data)
        mui.ajax("http://mdnwxapi.meitaitai.com.cn/"+url,{
                data : data,
                success : function (data){
                    console.log('返回：' , url , '\n' , data)
                    success(data)
                },
                error : error || ajax.error,
                dataType : 'json',
                type : 'post',
                timeout : 10000,
            }
        )
    }


    window.ajax_user=function(url,data,success,error){
        console.log('传入：' , url , '\n' , data)
        mui.ajax("http://mdnwxapi.meitaitai.com.cn/"+url,{
                data : data,
                xhrFields: {
                    withCredentials: true
                },
                success : function (data){
                    console.log('返回：' , url , '\n' , data)
                    success(data)
                },
                error : error || ajax.error,
                dataType : 'json',
                type : 'post',
                timeout : 10000,
            }
        )
    }

    ajax.error=function(xhr, type, errorThrown){
        console.log(xhr)

        console.log(type)

        console.log(errorThrown)

        mui.alert("<网络连接失败，请重新尝试一下>", "错误", "OK", null);
    }











})(mui,document);
